diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGiant.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGiant.java
index 51decd3b9..badeaf224 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGiant.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGiant.java
@@ -3,25 +3,26 @@ package net.minecraft.core.entity.monster;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.World;
 
-public class MobGiant extends MobMonster
+public class MobGiant extends MobZombie
 {
+    public static final int GIANT_SCALE = 6;
 
-    public MobGiant(World world)
+    public MobGiant(final World world)
     {
         super(world);
-        textureIdentifier = new NamespaceID("minecraft", "zombie");
-        moveSpeed = 0.5F;
-        attackStrength = 50;
-        heightOffset *= 6F;
-        setSize(bbWidth * 6F, bbHeight * 6F);
+        setTextureIdentifier("minecraft", "zombie");
+        this.moveSpeed = 0.5F;
+        this.attackStrength = 50;
+        this.heightOffset *= 6F;
+        setSize(this.bbWidth * GIANT_SCALE, this.bbHeight * GIANT_SCALE);
     }
     @Override
     public int getMaxHealth(){
         return super.getMaxHealth() * 10;
     }
     @Override
-	protected float getBlockPathWeight(int x, int y, int z)
+	protected float getBlockPathWeight(final int x, final int y, final int z)
     {
-        return world.getLightBrightness(x, y, z) - 0.5F;
+        return this.world.getLightBrightness(x, y, z) - 0.5F;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java
index f9e78d9d0..0bd600f44 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java
@@ -17,7 +17,7 @@ public abstract class MobMonster extends MobPathfinder
     implements Enemy
 {
 
-    public MobMonster(@Nullable World world)
+    public MobMonster(@NotNull final World world)
     {
         super(world);
         attackStrength = 2;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonsterArmored.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonsterArmored.java
index 13a350c64..c5c1f6400 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonsterArmored.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonsterArmored.java
@@ -21,7 +21,7 @@ public abstract class MobMonsterArmored<T extends IArmorShape>
     protected static final int DATA_ARMOR_START = 25;
     protected static final int FLAG_LEFT_HANDED = 4;
 
-    public MobMonsterArmored(final @Nullable World world) {
+    public MobMonsterArmored(final @NotNull World world) {
         super(world);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobScorpion.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobScorpion.java
index 6275738ac..839af5900 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobScorpion.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobScorpion.java
@@ -17,7 +17,7 @@ public class MobScorpion extends MobMonster
     public MobScorpion(World world)
     {
         super(world);
-        textureIdentifier = new NamespaceID("minecraft", "scorpion");
+        setTextureIdentifier("minecraft", "scorpion");
         setSize(1F, 0.2F);
         moveSpeed = 0.8F;
         scoreValue = 200;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java
index 14b1ec861..a3500037f 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java
@@ -26,7 +26,7 @@ public class MobSkeleton extends MobMonsterArmored<HumanArmorShape>
 
     public MobSkeleton(World world) {
         super(world);
-        textureIdentifier = new NamespaceID("minecraft", "skeleton");
+        setTextureIdentifier("minecraft", "skeleton");
         scoreValue = 500;
         mobDrops.add(new WeightedRandomLootObject(Items.AMMO_ARROW.getDefaultStack(), 0, 2));
         mobDrops.add(new WeightedRandomLootObject(Items.BONE.getDefaultStack(), 0, 2));
@@ -122,4 +122,9 @@ public class MobSkeleton extends MobMonsterArmored<HumanArmorShape>
 
         return HumanArmorShape.values()[index];
     }
+
+    @Override
+    public @Nullable ItemStack getHeldItem() {
+        return DEFAULT_HELD_ITEM;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSlime.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSlime.java
index a02eb8c4f..85f03b35a 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSlime.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSlime.java
@@ -23,7 +23,7 @@ public class MobSlime extends Mob
     {
         super(world);
         jumpDelay = 0;
-        textureIdentifier = new NamespaceID("minecraft", "slime");
+        setTextureIdentifier("minecraft", "slime");
         heightOffset = 0.0F;
         jumpDelay = 20;
         scoreValue = 100;
@@ -34,7 +34,7 @@ public class MobSlime extends Mob
     {
         super(world);
         jumpDelay = 0;
-        textureIdentifier = new NamespaceID("minecraft", "slime");
+        setTextureIdentifier("minecraft", "slime");
         heightOffset = 0.0F;
         jumpDelay = 20;
         scoreValue = 100;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSnowman.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSnowman.java
index 5b01ff77d..1fadbd2df 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSnowman.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSnowman.java
@@ -20,7 +20,7 @@ public class MobSnowman extends MobMonster
     public MobSnowman(World world)
     {
         super(world);
-        textureIdentifier = new NamespaceID("minecraft", "snowman");
+        setTextureIdentifier("minecraft", "snowman");
         moveSpeed = 0.5F;
         attackStrength = 5;
         scoreValue = 300;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSpider.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSpider.java
index f1072a45c..79e4e10f0 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSpider.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSpider.java
@@ -17,7 +17,7 @@ public class MobSpider extends MobMonster
     public MobSpider(World world)
     {
         super(world);
-        textureIdentifier = new NamespaceID("minecraft", "spider");
+        setTextureIdentifier("minecraft", "spider");
         setSize(1.4F, 0.9F);
         moveSpeed = 0.8F;
         scoreValue = 200;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombie.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombie.java
index 22d3f052b..5c27418a9 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombie.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombie.java
@@ -1,14 +1,8 @@
 package net.minecraft.core.entity.monster;
 
-import com.mojang.nbt.tags.CompoundTag;
-import com.mojang.nbt.tags.ListTag;
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.enums.HumanArmorShape;
-import net.minecraft.core.item.Item;
-import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
-import net.minecraft.core.item.material.ArmorMaterial;
-import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.weather.Weather;
@@ -16,15 +10,11 @@ import net.minecraft.core.world.weather.Weathers;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-import java.util.HashMap;
-import java.util.Map;
-import java.util.Random;
-
 public class MobZombie extends MobMonsterArmored<HumanArmorShape>
 {
-    public MobZombie(final World world) {
+    public MobZombie(final @NotNull World world) {
         super(world);
-        textureIdentifier = new NamespaceID("minecraft", "zombie");
+        setTextureIdentifier("minecraft", "zombie");
         moveSpeed = 0.5F;
         attackStrength = 5;
         scoreValue = 300;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombieArmored.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombieArmored.java
index a161e2c91..2a3423f1e 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombieArmored.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombieArmored.java
@@ -29,10 +29,10 @@ public class MobZombieArmored extends MobZombie implements IItemHolding
         DEFAULT_HELD_ITEM = new ItemStack(Items.TOOL_SWORD_IRON, 1);
     }
 
-    public MobZombieArmored(World world)
+    public MobZombieArmored(@NotNull final World world)
     {
         super(world);
-        textureIdentifier = new NamespaceID("minecraft", "zombie_armored");
+        setTextureIdentifier("minecraft", "zombie_armored");
         scoreValue = 1000;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java
index 1fa3117c4..ab6066da0 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java
@@ -36,7 +36,7 @@ public class MobZombiePig extends MobZombie
         super(world);
         angerLevel = 0;
         randomSoundDelay = 0;
-        textureIdentifier = new NamespaceID("minecraft", "pigzombie");
+        setTextureIdentifier("minecraft", "pigzombie");
         moveSpeed = 0.5F;
         attackStrength = 5;
         fireImmune = false;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index 4a1e29987..4bbd1bd99 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -144,8 +144,9 @@ public abstract class Player
         moveTo((double)chunkcoordinates.x + 0.5D, chunkcoordinates.y + 1, (double)chunkcoordinates.z + 0.5D, 0.0F, 0.0F);
 //        rotOffs = 180F;
         fireImmuneTicks = 20;
-        textureIdentifier = new NamespaceID("minecraft", "char");
+        setTextureIdentifier("minecraft", "char");
         damageRemainder = 0;
+        this.noAI = false;
     }
     @Override
     public int getMaxHealth(){
@@ -636,8 +637,9 @@ public abstract class Player
         this.heldObject = heldObject;
     }
 
+    @Override
     public @Nullable ICarriable getHeldObject() {
-        return heldObject;
+        return this.heldObject;
     }
 
     @Override
@@ -1620,7 +1622,7 @@ public abstract class Player
 		if(itemSlot == -1) {
 			if(getGamemode() == Gamemode.creative) {
 				int emptySlot = -1;
-				for(int i = 0; i < inventory.getContainerSize(); i++) {
+				for(int i = 0; i < 36; i++) {
 					if(inventory.getItem(i) == null) {
 						emptySlot = i;
 						break;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/projectile/Projectile.java b/game/core/src/main/java/net/minecraft/core/entity/projectile/Projectile.java
index 23fcf5efa..d84b04c5a 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/projectile/Projectile.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/projectile/Projectile.java
@@ -85,10 +85,10 @@ public class Projectile extends Entity {
     }
 
     @Override
-    public boolean shouldRenderAtSqrDistance(double distance)
+    public boolean shouldRenderAtSqrDistance(final double distance, final double viewDistanceModifier)
     {
-        double d1 = bb.getSize() * 4D;
-        d1 *= 64D;
+        double d1 = this.bb.getSize() * 4D;
+        d1 *= 64D * viewDistanceModifier;
         return distance < d1 * d1;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/util/collection/NamespaceID.java b/game/core/src/main/java/net/minecraft/core/util/collection/NamespaceID.java
index 89af7b7d0..2f85fc7db 100644
--- a/game/core/src/main/java/net/minecraft/core/util/collection/NamespaceID.java
+++ b/game/core/src/main/java/net/minecraft/core/util/collection/NamespaceID.java
@@ -17,8 +17,10 @@ public final class NamespaceID implements Comparator<NamespaceID>, Comparable<Na
     }
     public NamespaceID(String formattedString) throws HardIllegalArgumentException {
         if (!formattedString.contains(":")) throw new HardIllegalArgumentException("Formatted String '" + formattedString + "' missing ':' character all namespace ids must follow the format <namespace>:<value>!");
-        String[] split = formattedString.split(":");
-        if (split.length != 2) throw new HardIllegalArgumentException("Formatted String '" + formattedString + "' has more then 1 ':' character! all namespace ids must follow the format <namespace>:<value>!");
+        String[] split = formattedString.split(":", 2);
+        if (split.length != 2 || split[0].isEmpty()) throw new HardIllegalArgumentException("Formatted String '" + formattedString + "' is missing namespace! all namespace ids must follow the format <namespace>:<value>!");
+        if (split[1].isEmpty()) throw new HardIllegalArgumentException("Formatted String '" + formattedString + "' is missing value! all namespace ids must follow the format <namespace>:<value>!");
+        if (split[1].contains(":")) throw new HardIllegalArgumentException("Formatted String '" + formattedString + "' has more then 1 ':' character! all namespace ids must follow the format <namespace>:<value>!");
         namespace = split[0];
         value = split[1];
     }
diff --git a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
index f2d9785f7..54aa221c8 100644
--- a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
@@ -154,7 +154,7 @@ public class PlayerServer extends Player implements ContainerListener {
     }
 
     @Override
-	public void setWorld(World world)
+	public void setWorld(@NotNull final World world)
     {
         super.setWorld(world);
         playerController = new ServerPlayerController((WorldServer) world);
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/TestChunkProvider.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/TestChunkProvider.java
index 964ddb241..0f597f9cd 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/TestChunkProvider.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/TestChunkProvider.java
@@ -1,9 +1,9 @@
 package org.useless.seedviewer;
 
+import net.minecraft.core.util.collection.NamespaceID;
 import org.useless.seedviewer.collections.ChunkLocation;
 import org.useless.seedviewer.collections.ChunkPos2D;
 import org.useless.seedviewer.collections.ChunkPos3D;
-import org.useless.seedviewer.collections.NamespaceID;
 import org.useless.seedviewer.data.Biome;
 import org.useless.seedviewer.data.Chunk;
 import org.useless.seedviewer.gui.ChunkProvider;
@@ -22,7 +22,7 @@ public class TestChunkProvider implements ChunkProvider {
 
                     @Override
                     public NamespaceID getID() {
-                        return new NamespaceID("viewer:test");
+                        return new NamespaceID("viewer", "test");
                     }
 
                     @Override
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTABiome.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTABiome.java
index 0088af62d..e3f61e1d5 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTABiome.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTABiome.java
@@ -2,7 +2,8 @@ package org.useless.seedviewer.bta;
 
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.lang.I18n;
-import org.useless.seedviewer.collections.NamespaceID;
+import net.minecraft.core.util.HardIllegalArgumentException;
+import net.minecraft.core.util.collection.NamespaceID;
 import org.useless.seedviewer.data.Biome;
 
 public class BTABiome implements Biome {
@@ -18,7 +19,11 @@ public class BTABiome implements Biome {
 
     @Override
     public NamespaceID getID() {
-        return new NamespaceID(Registries.BIOMES.getKey(biome));
+        try {
+            return new NamespaceID(Registries.BIOMES.getKey(biome));
+        } catch (HardIllegalArgumentException e) {
+            throw new IllegalArgumentException(e);
+        }
     }
 
     @Override
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/data/Biome.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/data/Biome.java
index 57b70c018..5c4f56f7b 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/data/Biome.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/data/Biome.java
@@ -1,6 +1,6 @@
 package org.useless.seedviewer.data;
 
-import org.useless.seedviewer.collections.NamespaceID;
+import net.minecraft.core.util.collection.NamespaceID;
 
 public interface Biome {
     String getName();
diff --git a/util/seed-viewer/src/test/java/collections/NamespaceTest.java b/util/seed-viewer/src/test/java/collections/NamespaceTest.java
index e5b06e98d..1be1c8123 100644
--- a/util/seed-viewer/src/test/java/collections/NamespaceTest.java
+++ b/util/seed-viewer/src/test/java/collections/NamespaceTest.java
@@ -1,9 +1,10 @@
 package collections;
 
+import net.minecraft.core.util.HardIllegalArgumentException;
+import net.minecraft.core.util.collection.NamespaceID;
 import org.junit.jupiter.api.Assertions;
 import org.junit.jupiter.api.DisplayName;
 import org.junit.jupiter.api.Test;
-import org.useless.seedviewer.collections.NamespaceID;
 
 public class NamespaceTest {
     @Test
@@ -56,7 +57,7 @@ public class NamespaceTest {
 
     @Test
     @DisplayName("Test Namespace 1String Constructor")
-    void namespaceCreation2() {
+    void namespaceCreation2() throws HardIllegalArgumentException {
         String formatted_1 = "minecraft:value1";
         NamespaceID namespaceID_1 = new NamespaceID(formatted_1);
         Assertions.assertEquals(namespaceID_1.namespace, "minecraft");
@@ -76,11 +77,11 @@ public class NamespaceTest {
         Assertions.assertEquals(namespaceID_1.toString(), namespaceID_2.toString());
 
         Assertions.assertThrowsExactly(NullPointerException.class, () -> new NamespaceID(null));
-        Assertions.assertThrowsExactly(IllegalArgumentException.class, () -> new NamespaceID("minecraft::value1"));
-        Assertions.assertThrowsExactly(IllegalArgumentException.class, () -> new NamespaceID("minecraft:value1:"));
-        Assertions.assertThrowsExactly(IllegalArgumentException.class, () -> new NamespaceID(":value1"));
+        Assertions.assertThrowsExactly(HardIllegalArgumentException.class, () -> new NamespaceID("minecraft::value1"));
+        Assertions.assertThrowsExactly(HardIllegalArgumentException.class, () -> new NamespaceID("minecraft:value1:"));
+        Assertions.assertThrowsExactly(HardIllegalArgumentException.class, () -> new NamespaceID(":value1"));
         Assertions.assertDoesNotThrow(() -> new NamespaceID("minecraft:value"));
-        Assertions.assertThrowsExactly(IllegalArgumentException.class, () -> new NamespaceID("minecraft value"));
-        Assertions.assertThrowsExactly(IllegalArgumentException.class, () -> new NamespaceID("minecraft|value"));
+        Assertions.assertThrowsExactly(HardIllegalArgumentException.class, () -> new NamespaceID("minecraft value"));
+        Assertions.assertThrowsExactly(HardIllegalArgumentException.class, () -> new NamespaceID("minecraft|value"));
     }
 }
